var pattern = /(['`"]|&quot;)((\/)(builder|fonts|images|img|jClocksGMT|ml|prt)(\/)(.*?))(\?.*)?(\1)/g;
var hasUrlpattern = /(url\(\s*)((\/(builder|fonts|images|img|jClocksGMT|ml|prt))((\/).*)*(\/)(.*))(\s*\);)/g;
var hasHtmlPattern = /(['`"]|&quot;)((\/)(embed|message|urgent)(\/)[0-9]+\_[0-9]+)(.html)(\?.*)?(\1)/g;
var needHtmlPattern = /(['`"]|&quot;)((\/)(embed|message|urgent)(\/)[0-9]+\_[0-9]+)(\?.*)?(\1)/g;
var pathPattern = /^((\/)(builder|fonts|images|img|jClocksGMT|ml|prt)(\/)(.*?))(\?.*)?$/g;
var pathHasHtmlPattern = /^((\/)(embed|message|urgent)(\/)[0-9]+\_[0-9]+)(.html)(\?.*)?$/g;
var pathNeedHtmlPattern = /^((\/)(embed|message|urgent)(\/)[0-9]+\_[0-9]+)(\?.*)?$/g;
var SourcePatcher = /** @class */ (function () {
    function SourcePatcher() {
        this.modifiedBaseUri = SourcePatcher.removePrtVersionFromBaseUri();
    }

    SourcePatcher.removePrtVersionFromBaseUri = function () {
        return SourcePatcher.baseUri.replace(/\/prt\/v[0-9.]+/, '');
    };

    SourcePatcher.patch = function (source, baseUri) {
        // Use this.modifiedBaseUri to refer to the modified base URI
        this.modifiedBaseUri = baseUri;
        var patch = source.replace(pattern, "$1" + this.modifiedBaseUri + "$2$8")
            .replace(hasHtmlPattern, "$1" + this.modifiedBaseUri + "$2$6$7$8")
            .replace(needHtmlPattern, "$1" + this.modifiedBaseUri + "$2.html$6$7")
            .replace(hasUrlpattern, "url($1file://" + this.modifiedBaseUri + "$2$9");
        return patch;
    };

    SourcePatcher.fixPath = function (path) {
        // Use this.modifiedBaseUri for fixPath logic
        var fixPath = path.replace(pathPattern, this.modifiedBaseUri + "$&")
            .replace(pathHasHtmlPattern, this.modifiedBaseUri + "$&")
            .replace(pathNeedHtmlPattern, this.modifiedBaseUri + "$1.html$5");
        return fixPath;
    };
    
    SourcePatcher.baseUri = ""; // Static property remains unchanged
    return SourcePatcher;
}());

// const str = `<img src="/ml/9/999_test.jpg">
// var fn = '/ml/9/999_kkkk.jpg';
// <script src="/builder/test.js" style="background-image: url(&quot;/ml/2099/test.jpg&quot;)">
// "/embed/299_17?tx=15"
// "/embed/299_16.html?tx=45"
// "/embed/299_17"
// "/embed/299_16.html"`;
// console.log(SourcePatcher.patch(str));
// console.log(SourcePatcher.fixPath('/embed/123_456.html?tx=45'));
// console.log(SourcePatcher.fixPath('/embed/123_456?tx=45'));
// SourcePatcher.baseUri = '/test/123';
// console.log(SourcePatcher.patch(str));
// console.log(SourcePatcher.fixPath('/embed/123_456.html?tx=45'));
// console.log(SourcePatcher.fixPath('/embed/123_456?tx=45'));
