/// <reference path="../../../Dev/src/overlaypanel.ts" />

class PlayerHost {
    static blackoutschedule: BlackoutSchedule;
    static pal: any;

    static init() {
        PlayerHost.pal = getKorbytPlayerPal();
        console.log(PlayerHost.pal);

        var keyHandler = function (e: KeyboardEvent) {
            // console.log('PlayerHost: keyHandler(' + JSON.stringify(e) + ')');
            switch (e.code) {
                case "Escape": // escape
                    return e.preventDefault();
                case "KeyC": // 'C' --- Clear-Cache
                    if (e.ctrlKey && e.altKey) {
                        e.preventDefault();
                        PlayerHost.pal.forceSettings = true;
                        PlayerHost.pal.saveSettings(function () {
                            // PlayerHost.pal.sendMessage('restart');
                            PlayerHost.pal.sendMessage('cacheclear');
                        });
                    }
                    return;
                case "KeyX": // 'X' --- Exit Player
                    if (e.ctrlKey && e.altKey) {
                        e.preventDefault();
                        PlayerHost.pal.sendMessage('exit');
                    }
                    return;
                case "KeyI":// 'I' --- Toggle Identity panel
                    if (e.ctrlKey && e.altKey) {
                        e.preventDefault();
                        PlayerHost.ToggleIdentityPanel();
                    }
                    return;
                case "KeyR":// 'R' --- Reboot
                    if (e.ctrlKey && e.altKey) {
                        e.preventDefault();
                        PlayerHost.pal.Reboot('Keyboard CTRL+ALT+R');
                    }
                    return;
            }
        }

        //prevent existing fullscreen on escape key press
        window.onkeydown = keyHandler;
        // var p: any = {};
        // p.provisioning = { provisioned: false };
        // if (PlayerHost.pal.provisioning && PlayerHost.pal.provisioning.provisioned) {
        //     p.provisioning = PlayerHost.pal.provisioning;
        // }
        // PlayerHost.pal.checkinGetInfo(function (checkin: iCheckin, err?: string) {
        //     try {
        //         if (err) {
        //             console.error(err);
        //             _klogger.error(err);
        //             // $('#playerhost').html(`<h1>${err}</h1>`)
        //         } else {
        //             if (PlayerHost.pal.provisioning && PlayerHost.pal.provisioning.cms && PlayerHost.pal.provisioning.provisioned) {
        //                 if (fullDownloadPath) {
        //                     p.checkin = checkin;
        //                     p.provisioning = PlayerHost.pal.provisioning;
        //                     console.log(p);
        //                     let parms = Utility.encodeURIObject(p);
        //                     let url = PlayerHost.pal.playerLoadingUrl(parms);
        //                     main.openWindow(url);
        //                 }
        //             }
        //         }
        //     } catch (err) {
        //         console.error(err);
        //         _klogger.error(err);
        //     }
        // });
    }

    static identityPanelShown: boolean = false;
    static ShowIdentityPanel(show: boolean) {
        if (show) {
            PlayerHost.pal.provisioningDetails(function (details: iNameValuePair[]) {
                if (PlayerHost.pal.provisioning.cms) {
                    details.unshift({ n: 'Server', v: Utility.getHostname(PlayerHost.pal.provisioning.cms) });
                }
                details.push({ n: 'Provisioning Token', v: PlayerHost.pal.provisioningToken });
                if (PlayerHost.pal.checkInData && PlayerHost.pal.checkInData.instructions && PlayerHost.pal.checkInData.instructions.playerID) {
                    details.push({ n: 'Player ID', v: `${PlayerHost.pal.checkInData.instructions.playerID}` });
                }
                details.push({ n: 'Caching', v: `${main.cachingPlayerEnabled}` });
                OverlayPanel.show(details);
                PlayerHost.identityPanelShown = true;
            });
        } else {
            OverlayPanel.hide();
            PlayerHost.identityPanelShown = false;
        }
    }

    static progressvisible = false;
    static showResourceManagerProgress() {
        let progress = localStorage.getItem('KorbytDownloadProgress');
        let existing = <HTMLDivElement>document.getElementById('resourceManagerProgress');
        if (progress) {
            if (!existing) {
                existing = document.createElement('div');
                existing.className = 'resourceManagerProgress';
                existing.id = 'resourceManagerProgress';
                document.body.insertBefore(existing, document.body.firstChild);
            }

            existing.innerText = progress;
            setTimeout(PlayerHost.showResourceManagerProgress, 2 * 1000);
        } else {
            if (existing) {
                existing.remove();
            }
        }
    }

    static ToggleIdentityPanel() {
        console.log('ToggleIdentityPanel(' + !PlayerHost.identityPanelShown + ')');
        return PlayerHost.ShowIdentityPanel(!PlayerHost.identityPanelShown);
    }

}

$(function () {
    PlayerHost.init();
});